| OrbbecSDK 1.5.7 OrbbecSDK: Software-Development-Kit for Orbbec 3D-Sensor devices

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Attributes | Friends | List of all members
ob::Frame Class Reference

`#include <Frame.hpp>`

Inheritance diagram for ob::Frame:

## Public Member Functions
| Frame (std::unique_ptr< FrameImpl > impl)
| Frame (Frame &frame)
virtual | ~Frame () noexcept
virtual OBFrameType | type ()
| Get the type of frame. More...
virtual OBFormat | format ()
| Get the format of the frame. More...
virtual uint64_t | index ()
| Get the sequence number of the frame. More...
virtual void * | data ()
| Get frame data. More...
virtual uint32_t | dataSize ()
| Get the frame data size. More...
uint64_t | timeStamp ()
| Get the hardware timestamp of the frame. More...
uint64_t | timeStampUs ()
| Get the hardware timestamp of the frame us. More...
uint64_t | systemTimeStamp ()
| Get frame system timestamp. More...
template<typename T >
bool | is ()
| Check if the runtime type of the frame object is compatible with a given type. More...
template<typename T >
std::shared_ptr< T > | as ()
| Frame object type conversion. More...

## Protected Attributes
std::unique_ptr< FrameImpl > | impl_

## Friends
class | Filter
class | Recorder
class | FrameHelper

## Detailed Description

Definition at line 45 of file Frame.hpp.

## Constructor & Destructor Documentation

ob::Frame::Frame | ( | std::unique_ptr< FrameImpl > | impl | ) |

ob::Frame::Frame | ( | Frame & | frame | ) |

virtual ob::Frame::~Frame | ( |  | ) |
| virtual noexcept

## Member Function Documentation

virtual OBFrameType ob::Frame::type | ( |  | ) |
| virtual

Get the type of frame.

Returns
  OBFrameType returns the type of frame

virtual OBFormat ob::Frame::format | ( |  | ) |
| virtual

Get the format of the frame.

Returns
  OBFormat returns the format of the frame

virtual uint64_t ob::Frame::index | ( |  | ) |
| virtual

Get the sequence number of the frame.

Returns
  uint64_t returns the sequence number of the frame

virtual void* ob::Frame::data | ( |  | ) |
| virtual

Get frame data.

Returns
  void* returns frame data

virtual uint32_t ob::Frame::dataSize | ( |  | ) |
| virtual

Get the frame data size.

Returns
  uint32_t returns the frame data size If it is point cloud data, it returns the number of bytes occupied by all point sets. If you need to find the number of points, you need to divide the dataSize by the structure size of the corresponding point type.

uint64_t ob::Frame::timeStamp | ( |  | ) |

Get the hardware timestamp of the frame.

Returns
  uint64_t returns the time stamp of the frame hardware

uint64_t ob::Frame::timeStampUs | ( |  | ) |

Get the hardware timestamp of the frame us.

Returns
  uint64_t returns the time stamp of the frame hardware, unit us

uint64_t ob::Frame::systemTimeStamp | ( |  | ) |

Get frame system timestamp.

Returns
  uint64_t returns the time stamp of the frame hardware

template<typename T >

bool ob::Frame::is | ( |  | ) |

Check if the runtime type of the frame object is compatible with a given type.

Template Parameters

  T | Given type

Returns
  bool returns result

Definition at line 547 of file Frame.hpp.

template<typename T >

std::shared_ptr<T> ob::Frame::as | ( |  | ) |
| inline

Frame object type conversion.

Template Parameters

  T | Target type

Returns
  std::shared_ptr<T> returns the result, if it cannot be converted, an exception will be thrown

Definition at line 188 of file Frame.hpp.

## Friends And Related Function Documentation

friend class Filter
| friend

Definition at line 196 of file Frame.hpp.

friend class Recorder
| friend

Definition at line 197 of file Frame.hpp.

friend class FrameHelper
| friend

Definition at line 198 of file Frame.hpp.

## Member Data Documentation

std::unique_ptr<FrameImpl> ob::Frame::impl_
| protected

Definition at line 47 of file Frame.hpp.

The documentation for this class was generated from the following file:

- /root/libobsensor/include/libobsensor/hpp/Frame.hpp